
module.exports = {
    window: {
        width: '100%',
        height: '100%',
        backgroundColor:'#454545',
        exitOnClose: true,
        fullscreen:false
    },
    container: {
        backgroundColor: '#000',
        borderRadius:'10',
        width: '720',
        height: '452',
        borderColor:'#009933',
        borderWidth:'4'
    },
    containerCanvas: {
        width: '720',
        height: '452',
        backgroundColor: '#686868',
        borderWidth:'4',
        borderRadius:'10',
        borderColor:'#686868'
    },
    whiteCont: {
        backgroundColor: '#FFF',
        borderRadius:'10',
        width: '480',
        height: '272',
        borderColor:'#FFF',
        borderWidth:'2'
    },
    textSmall: {
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 25 },
    },
    textMedium: {
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 35 },
    },
    textMediumUL: {
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 35 },
    },
    textLarge: {
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 45 },
    },
    textXLarge: {
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 55 }
    },
    textButtonGreenLarge: {
        borderRadius: '10',
        borderColor: '#6E6E6E',
        borderWidth: '2',
        backgroundColor: '#009933',
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 35 }
    },
    textButtonGreen: {
        borderRadius: '10',
        borderColor: '#6E6E6E',
        borderWidth: '2',
        backgroundColor: '#009933',
        fontStretch: 'ultra-condensed',
        color: '#FFFFFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 25 }
    },
    textBox: {
        color:'#fff',
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        font: { fontSize: 25 },
    },
    stdButton: {
        fontStretch: 'ultra-condensed',
        color: '#FFF',
        fontWeight: 'bold',
        textAlign:'center',
        font: { fontSize: 25 },
        backgroundColor: '#009933',
        backgroundSelectedColor : '#4A4A4A',
        borderRadius: '10',
        borderColor: '#6E6E6E',
        borderWidth: '3',
        height: 55
    },
    _extend: function(obj1, obj2){
        var newobj = {};
        for(var attr in obj1){
            newobj[attr] = obj1[attr];
        }
        for(var attr in obj2){
            newobj[attr] = obj2[attr];
        }
        return newobj;
    },
    _numberToString: function(val,precision,paddingLen){
        if(val == null || val == undefined){
            val = 0;
        }
        if(typeof(val)=='string'){
            return val;
        }
        val= val.toFixed(precision);
        return (new Array(paddingLen + 1).join('0') + val).slice(-paddingLen);
    }
};
