/*!
 * @file 12-spreader.js
 *
 * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
 * @note Designed with Titanium for iOS and Android devices
 * @note This file contains propritary information
 * @copyright 2014 Riverside MFG LLC
 * @section DESCRIPTION
 *
 * This source file contains the class to draw/update window: CFG 12-spreader
 */

var window;                /*!< Window object for self */
var activeCtrls = {};    /*!< Controls on window object */
var sendBack = {};        /*!< Object which contains commands to send back to server */
var style;                /*!< UI Style Wrapper */

module.exports = {
    /*!
     * This flag determins if the current window should be skipped in the rotation of windows
     */
    'skip': false,
    /*!
     * This is the ID of the page
     */
    'id':'cfg.sprd5',
    /*!
     * This function is called to switch to normal mode and should be remapped by the WindowManager
     */
    'switchToNormal': function(){},
    /*!
     * This function is called to go to page 0 on the configuration menu
     */
    'gotoPage0': function(){},
    /*!
     * This function sets up the display elements for the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'init': function(uiStyle,swipe,actionControllers){
        var cont,views=[];
        style = uiStyle;
        window = Titanium.UI.createWindow(uiStyle._extend(uiStyle.window, {
            title:'Configuration: Granular Ratio\'s'
        }));
        cont = Titanium.UI.createView(uiStyle.containerCanvas);
        window.add(cont);
        window.addEventListener('swipe',swipe);
        
        //title block
        views[0] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '1%',top: '1%',height: '15%',width: '98%'}));
        cont.add(views[0]);
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textMedium,{text:"Granular Ratio\'s Pg. 12",width:'100%',height:'100%',left: '0',top: '0'})));
        views[0].children[0].addEventListener('click',module.exports.gotoPage0);
        
        //data block
        views[1] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '1%',top: '17%',height: '82%',width: '98%'}));
        cont.add(views[1]);
        
        //titles
        views[1].add(Titanium.UI.createView({width : 6, left : '36%', height : '100%', backgroundColor: '#009933', top : '0'}));
        activeCtrls['name1'] = new actionControllers.TextEntry(uiStyle._extend(uiStyle.stdButton,{title:"",width:150,left:'10%',top: '2%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'4':toSend
            		}
            	}
            };
        });
        views[1].add(activeCtrls['name1'].getObject());
        activeCtrls['name2'] = new actionControllers.TextEntry(uiStyle._extend(uiStyle.stdButton,{title:"",width:150,left:'10%',top: '18%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'5':toSend
            		}
            	}
            };
        });
        views[1].add(activeCtrls['name2'].getObject());
        activeCtrls['name3'] = new actionControllers.TextEntry(uiStyle._extend(uiStyle.stdButton,{title:"",width:150,left:'10%',top: '34%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'6':toSend
            		}
            	}
            };
        });
        views[1].add(activeCtrls['name3'].getObject());
        activeCtrls['name4'] = new actionControllers.TextEntry(uiStyle._extend(uiStyle.stdButton,{title:"",width:150,left:'10%',top: '50%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'7':toSend
            		}
            	}
            };
        });
        views[1].add(activeCtrls['name4'].getObject());
        activeCtrls['name5'] = new actionControllers.TextEntry(uiStyle._extend(uiStyle.stdButton,{title:"",width:150,left:'10%',top: '66%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'8':toSend
            		}
            	}
            };
        });
        views[1].add(activeCtrls['name5'].getObject());
        
        //controls
        activeCtrls["ratio1"] = new actionControllers.SliderButton(uiStyle._extend(uiStyle.stdButton,{title:"",width:250,left:'40%',top: '2%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'9':toSend
            		}
            	}
            };
        },false,{min:50,max:200,inc:1,multi:1,units:'%'});
        views[1].add(activeCtrls["ratio1"].getObject());
        activeCtrls["ratio2"] = new actionControllers.SliderButton(uiStyle._extend(uiStyle.stdButton,{title:"",width:250,left:'40%',top: '18%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'10':toSend
            		}
            	}
            };
        },false,{min:50,max:200,inc:1,multi:1,units:'%'});
        views[1].add(activeCtrls["ratio2"].getObject());
        activeCtrls["ratio3"] = new actionControllers.SliderButton(uiStyle._extend(uiStyle.stdButton,{title:"",width:250,left:'40%',top: '34%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'11':toSend
            		}
            	}
            };
        },false,{min:50,max:200,inc:1,multi:1,units:'%'});
        views[1].add(activeCtrls["ratio3"].getObject());
        activeCtrls["ratio4"] = new actionControllers.SliderButton(uiStyle._extend(uiStyle.stdButton,{title:"",width:250,left:'40%',top: '50%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'12':toSend
            		}
            	}
            };
        },false,{min:50,max:200,inc:1,multi:1,units:'%'});
        views[1].add(activeCtrls["ratio4"].getObject());
        activeCtrls["ratio5"] = new actionControllers.SliderButton(uiStyle._extend(uiStyle.stdButton,{title:"",width:250,left:'40%',top: '66%'}),function(toSend){
        	sendBack = {
            	'cfg':{
            		'sprdc':{
            			'13':toSend
            		}
            	}
            };
        },false,{min:50,max:200,inc:1,multi:1,units:'%'});
        views[1].add(activeCtrls["ratio5"].getObject());
    },
    /*!
     * This function opens the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'open': function(){
        Ti.API.log('opening');
        Ti.API.log(window);
        window.open();
    },
    /*!
     * This function closes the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'close': function(){
        window.close();
    },
    /*!
     * This function updates the active controls on the current window view
     * with new data pushed from the stack.
     *
     * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     * 
     * @param data JSON data object
     */
    'update': function(data){
        if(data == false){
            return;
        }
        activeCtrls['name1'].value(data.s.cfg.sprdc[4]);
        activeCtrls['name2'].value(data.s.cfg.sprdc[5]);
        activeCtrls['name3'].value(data.s.cfg.sprdc[6]);
        activeCtrls['name4'].value(data.s.cfg.sprdc[7]);
        activeCtrls['name5'].value(data.s.cfg.sprdc[8]);
        activeCtrls['ratio1'].value(data.s.cfg.sprdc[9]);
        activeCtrls['ratio2'].value(data.s.cfg.sprdc[10]);
        activeCtrls['ratio3'].value(data.s.cfg.sprdc[11]);
        activeCtrls['ratio4'].value(data.s.cfg.sprdc[12]);
        activeCtrls['ratio5'].value(data.s.cfg.sprdc[13]);
    },
    /*!
     * This function gets an object of data to send back to the server
     * based on any user requested actions
     *
     * @author Kevin Wijesekera <kwijesekera@riversidemfg.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     * 
     * @return object of data
     */
    'getDataTx': function(){
        var temp = sendBack;
        sendBack = {};
        return temp;
    }
    
};