/*!
 * @file 1-oper.js
 *
 * @author Kevin Wijesekera <kwijesekera@munciepower.com>
 * @note Designed with Titanium for iOS and Android devices
 * @note This file contains propritary information
 * @copyright 2014 Riverside MFG LLC
 * @section DESCRIPTION
 *
 * This source file contains the class to draw/update window: 4-datalog
 */

var window;                /*!< Window object for self */
var activeCtrls = {};    /*!< Controls on window object */
var style;

module.exports = {
    /*!
     * This flag determins if the current window should be skipped in the rotation of windows
     */
    'skip': false,
    /*!
     * This function sets up the display elements for the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@munciepower.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'init': function(uiStyle,swipe,back){
        var cont,views=[];
        style = uiStyle;
        window = Titanium.UI.createWindow(uiStyle._extend(uiStyle.window, {
            title:'Datalogging'
        }));
        cont = Titanium.UI.createView(uiStyle.containerCanvas);
        window.add(cont);
        window.addEventListener('swipe',swipe);
        window.addEventListener('android:back',function(e){
			back();
        	window.close();
        });
        
        views[0] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '1%',top: '1%',height: '50%',width: '48%'}));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"TOTALS",width:'100%',height:'20%',left: '0%',top: '0'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"GRAN",width:'25%',height:'20%',left: '0',top: '20%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"LIQ",width:'25%',height:'20%',left: '0',top: '40%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"AUTO",width:'25%',height:'20%',left: '0',top: '60%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"MAN",width:'25%',height:'20%',left: '0',top: '80%'})));
    
        activeCtrls['granT'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'50%',height:'20%',left: '25%',top: '20%'}));
        activeCtrls['liqT'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'50%',height:'20%',left: '25%',top: '40%'}));
        activeCtrls['autoT'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'50%',height:'20%',left: '25%',top: '60%'}));
        activeCtrls['manT'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'50%',height:'20%',left: '25%',top: '80%'}));
        
        views[0].add(activeCtrls['granT']);
        views[0].add(activeCtrls['liqT']);
        views[0].add(activeCtrls['autoT']);
        views[0].add(activeCtrls['manT']);
    
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"LBS",width:'25%',height:'20%',left: '75%',top: '20%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"GAL",width:'25%',height:'20%',left: '75%',top: '40%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"MI",width:'25%',height:'20%',left: '75%',top: '60%'})));
        views[0].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"MI",width:'25%',height:'20%',left: '75%',top: '80%'})));
        
    
        views[1] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '1%',top: '52%',height: '10%',width: '48%'}));
        activeCtrls['speed'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"Speed: 00 MPH",width:'100%',height:'100%',left: '0%',top: '0%'}));
        views[1].add(activeCtrls['speed']);
        
        views[2] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '1%',top: '63%',height: '35%',width: '48%'}));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"AVERAGES",width:'100%',height:'20%',left: '0%',top: '0'})));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"GRAN",width:'25%',height:'26%',left: '0',top: '20%'})));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"LIQ",width:'25%',height:'26%',left: '0',top: '46%'})));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"SPEED",width:'25%',height:'26%',left: '0',top: '72%'})));
    
        activeCtrls['granA'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'45%',height:'26%',left: '25%',top: '20%'}));
        activeCtrls['liqA'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'45%',height:'26%',left: '25%',top: '46%'}));
        activeCtrls['speedA'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"0000000",width:'45%',height:'26%',left: '25%',top: '72%'}));
        
        views[2].add(activeCtrls['granA']);
        views[2].add(activeCtrls['liqA']);
        views[2].add(activeCtrls['speedA']);
    
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"LBS/MI",width:'30%',height:'26%',left: '70%',top: '20%'})));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"Gal/Ton",width:'30%',height:'26%',left: '70%',top: '46%'})));
        views[2].add(Titanium.UI.createLabel(uiStyle._extend(uiStyle.textSmall,{text:"MPH",width:'30%',height:'26%',left: '70%',top: '72%'})));
        
        views[3] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '51%',top: '1%',height: '15%',width: '48%'}));
        activeCtrls['truckid'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textMedium,{text:"Truck ID: 11111",width:'100%',height:'100%',left: '0%',top: '0%',textAlign:'center'}));
        views[3].add(activeCtrls['truckid']);
        
        views[4] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '51%',top: '17%',height: '30%',width: '48%'}));
        activeCtrls['time'] = Titanium.UI.createLabel(uiStyle._extend(uiStyle.textMedium,{text:"Tue, APR 02 2013\n01:46 PM",width:'100%',height:'100%',left: '0%',top: '0%',textAlign:'center'}));
        views[4].add(activeCtrls['time']);
        
        views[5] = Titanium.UI.createView(uiStyle._extend(uiStyle.container,{left: '51%',top: '49%',height: '50%',width: '48%'}));
        
        for(var i=0;i<views.length;i++){
            cont.add(views[i]);
        }
    },
    /*!
     * This function opens the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@munciepower.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'open': function(){
        window.open();
    },
    /*!
     * This function closes the current window view
     *
     * @author Kevin Wijesekera <kwijesekera@munciepower.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     */
    'close': function(){
        window.close();
    },
    /*!
     * This function updates the active controls on the current window view
     * with new data pushed from the stack.
     *
     * @author Kevin Wijesekera <kwijesekera@munciepower.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     * 
     * @param data JSON data object
     */
    'update': function(data){
        if(!data || !data.d || !data.d[0] || !data.s.rt){
            return;
        }
        activeCtrls['granT'].text = style._numberToString(data.d[0].dl[1],0,7);
        activeCtrls['liqT'].text = style._numberToString(data.d[0].dl[3],0,7);
        activeCtrls['autoT'].text = style._numberToString(data.d[0].dl[4],0,7);
        activeCtrls['manT'].text = style._numberToString(data.d[0].dl[5],0,7);
        
        activeCtrls['speed'].text = 'Speed: '+ data.d[0].gui[17].toString() + ' MPH';
        
        activeCtrls['granA'].text = style._numberToString(data.d[0].dl[6],0,7);
        activeCtrls['liqA'].text = style._numberToString(data.d[0].dl[7],0,7);
        activeCtrls['speedA'].text = style._numberToString(data.d[0].dl[8],0,7);
        
        activeCtrls['truckid'].text = 'Truck ID: '+data.s.rt.tid.toString();
        
        activeCtrls['time'].text = data.s.rt.tm.toString();
        
    },
    /*!
     * This function gets an object of data to send back to the server
     * based on any user requested actions
     *
     * @author Kevin Wijesekera <kwijesekera@munciepower.com>
     * @date 11/25/2014
     * @note Designed with Titanium API ver. 3.4.1
     * 
     * @return object of data
     */
    'getDataTx': function(){
        return {};
    }
};